; ---------------------------------------------------------------------------
; Handle all stores to the Complex Interface Adapters (6526)
; ---------------------------------------------------------------------------
Cia_Reset:  Push  Ds
            Push  Eax
            Mov   Ds,[Iodirect]
            Xor   Eax,Eax
            Mov   [Dword 0DC00h],0000FFFFh
            Mov   [0DC04h],Eax
            Mov   [0DC08h],Eax
            Mov   [0DC0Ch],Eax
            Mov   [Dword 0DD00h],0000FFFFh
            Mov   [0DD04h],Eax
            Mov   [0DD08h],Eax
            Mov   [0DD0Ch],Eax
            Mov   [Cia1_Imask],Al
            Mov   [Cia2_Imask],Al
            Pop   Eax
            Pop   Ds
            Ret

; ---------------------------------------------------------------------------
Align 2
Cia1        Dw    St_Dc00,St_Dc01,St_Dc02,St_Dc03
            Dw    St_Dc04,St_Dc05,St_Dc06,St_Dc07
            Dw    St_Dc08,St_Dc09,St_Dc0a,St_Dc0b
            Dw    St_Dc0c,St_Dc0d,St_Dc0e,St_Dc0f
Align 10h
St_Cia1:    Mov   Bx,Di
            And   Bx,0Fh
            Jmp   [Cia1+Bx+Di-0DC00h]
; ---------------------------------------------------------------------------
Align 2
Cia2        Dw    St_Dd00,St_Dd01,St_Dd02,St_Dd03
            Dw    St_Dd04,St_Dd05,St_Dd06,St_Dd07
            Dw    St_Dd08,St_Dd09,St_Dd0a,St_Dd0b
            Dw    St_Dd0c,St_Dd0d,St_Dd0e,St_Dd0f
Align 10h
St_Cia2:    Mov   Bx,Di
            And   Bx,0Fh
            Jmp   [Cia2+Bx+Di-0DD00h]
; ---------------------------------------------------------------------------
Evendata
TableCia    Dw    Keys,Joy1,Joy2
Align 10h
St_Dc00:    Mov   Bl,[Di+2]
            Not   Bl
            Or    Al,Bl
            Mov   [Shadowdc00],Al
            Mov   Bl,[Key_Mode]
            Jmp   [TableCia+Bx]

Keys:       Mov   [Di],Al
            Call  Setdc01
            Jmp   Next
Joy2:       And   Al,[Key_Joystat+0]
Joy1:       Mov   [Di],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Setdc01:    Push  Ds                ; Emulate input on DC01 
            push  Di               
            Mov   Ds,[Iodirect]
            Mov   Al,[0DC00h]
            Mov   Bl,0
            Mov   Di,0
@@1:        Shr   Al,1
            Jc    @@2
            Or    Bl,[Keymatrix+Di]
@@2:        Inc   Di
            Cmp   Di,8
            Jne   @@1
            Not   Bl
            Mov   Al,[0DC03h]
            Not   Al
            Or    Al,[0DC01h]
            And   Al,Bl
            Mov   [0DC01h],Al
            Pop   Di 
            pop   Ds
            Ret
; ---------------------------------------------------------------------------
St_Dc01:    Cmp   [Key_Mode],Key_Joy1
            Jne   @@1
            Mov   Bl,[Di+2]
            Not   Bl
            Or    Al,Bl
            And   Al,[Key_Joystat+1]
            Mov   [Di],Al
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc02:    Mov   [Di],Al
            Not   Al
            Or    [Di-2],Al
            Cmp   [Key_Mode],Key_Joy2
            Jne   @@1
            Mov   Al,[Key_Joystat+0]
            And   [Di-2],Al
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc03:    Mov   [Di],Al
            Not   Al
            Or    [Di-2],Al
            Cmp   [Key_Mode],Key_Joy1
            Jne   @@1
            Mov   Al,[Key_Joystat+1]
            And   [Di-2],Al
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc04:    Mov  [Byte Timer_Rate+2*0],Al
            Jmp  Next
St_Dc05:    Mov  [Byte Timer_Rate+2*0+1],Al
            Jmp  Next
Align 10h
St_Dc06:    Mov  [Byte Timer_Rate+2*1],Al
            Jmp  Next
St_Dc07:    Mov  [Byte Timer_Rate+2*1+1],Al
            Jmp  Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc0d:    ;Mov   [Byte Di],0
            Xor   Al,80h
            Jns   @@1
            Not   Al
            And   [Cia1_Imask],Al
            Jmp   Next
@@1:        Or    [Cia1_Imask],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc0e:    Mov   [Di],Al
            Mov   Bl,0
            Test  Al,1
            Je    @@1
            Call  Timer_Start
            Jmp   Next
@@1:        Call  Timer_Stop
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc0f:    Mov   [Di],Al
            Mov   Bl,1
            Test  Al,1
            Je    @@1
            Call  Timer_Start
            Jmp   Next
@@1:        Call  Timer_Stop
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd00:    Mov   Bl,[Di+2]
            And   Al,Bl
            Not   Bl
            And   Bl,[Di]
            Or    Al,Bl
            Xchg  Al,[Di]
            Xor   Al,[Di]
            And   Al,3
            Je    @@1
            Call  Flagrefresh
            Mov   [Sprite_Reimage],-1
            Mov   [Sprite_Update],-1
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd01:    Mov   Bl,[Di+2]
            And   Al,Bl
            Not   Bl
            And   Bl,[Di]
            Or    Al,Bl
            Mov   [Di],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd02:
St_Dd03:    Mov   [Di],Al
            Not   Al
            Or    [Di-2],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd04:    Mov  [Byte Timer_Rate+2*2],Al
            Jmp  Next
St_Dd05:    Mov  [Byte Timer_Rate+2*2+1],Al
            Jmp  Next
Align 10h
St_Dd06:    Mov  [Byte Timer_Rate+2*3],Al
            Jmp  Next
St_Dd07:    Mov  [Byte Timer_Rate+2*3+1],Al
            Jmp  Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd0d:    ;Mov   [Byte Di],0
            Xor   Al,80h
            Jns   @@1
            Not   Al
            And   [Cia2_Imask],Al
            Jmp   Next
@@1:        Or    [Cia2_Imask],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd0e:    Mov   [Di],Al
            Mov   Bl,2
            Test  Al,1
            Je    @@1
            Call  Timer_Start
            Jmp   Next
@@1:        Call  Timer_Stop
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dd0f:    Mov   [Di],Al
            Mov   Bl,3
            Test  Al,1
            Je    @@1
            Call  Timer_Start
            Jmp   Next
@@1:        Call  Timer_Stop
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_Dc08:
St_Dc09:
St_Dc0a:
St_Dc0b:
St_Dc0c:
St_Dd08:
St_Dd09:
St_Dd0a:
St_Dd0b:
St_Dd0c:
            Mov   [Di],Al
            Jmp   Next
; ---------------------------------------------------------------------------
