; ---------------------------------------------------------------------------
; swapSeg: 0000-1FFF: A-Ram when not in
;          2000-3FFF: A-Ram layout when not in
;          4000-5FFF: E-Ram when not in
;          6000-7FFF: E-Ram layout when not in
;          8000-8FFF: D-Ram when not in
;          9000-9FFF: IO when not in
;          A000-AFFF: D-Ram layout when not in
; ---------------------------------------------------------------------------
Debug=0

Reg_Pc Equ Si
Reg_X  Equ Dl
Reg_Y  Equ Dh
Reg_A  Equ Ch
Reg_S  Equ Cl
Reg_Z  Equ Ah
Reg_C  Equ Bp

Flag_S = 80h
Flag_V = 40h
Flag_5 = 20h
Flag_B = 10h
Flag_D = 08h
Flag_I = 04h
Flag_Z = 02h
Flag_C = 01h
Flag_N = Flag_S

Evendata
Aromseg          Dw    ?
Dromseg          Dw    ?
Eromseg          Dw    ?
Ramseg           Dw    ?
Swapseg          Dw    ?
Layoutseg        Dw    ?
Aramdirect       Dw    ?
Dramdirect       Dw    ?
Eramdirect       Dw    ?
Dromdirect       Dw    ?
Aramlayout       Dw    ?
Dramlayout       Dw    ?
Eramlayout       Dw    ?
Iodirect         Dw    ?
St_Table         Dw    St_Norm,St_Arom,St_Drom,St_Erom,St_0001
                 Dw    St_Cia1,St_Cia2,St_Sid,St_Vic
                 Dw    St_Video1,St_Video2,St_Video3,St_Video4
                 Dw    St_Video5,St_Video6
Last1            Db    ?
Dmap0001         Db    1,0,0,0,1,2,2,2

Flags            Db    ?
Evendata
SPtr             Db    ?,1

Timer_Freq       =     2000
Timer_On         Db    4 Dup (?)
Evendata
Timer_Rate       Dw    4 Dup (?)
Timer_Addr       Dw    0DC04h,0DC06h,0DD04h,0DD06h
Timer_Step       =     980000/Timer_Freq
Cia1_Imask       Db    ?
Cia2_Imask       Db    ?

Evendata
Bpsave           Dw    ?
Dssave           Dw    ?
Save08           Dd    ?
Save09           Dd    ?
Cpu              Dw    ?
Video            Dw    ?

Wantrefresh      Db    ?
DacArray         Db    00,00,00 ; Black
                 Db    63,63,63 ; White
                 Db    50,00,00 ; Red
                 Db    00,63,63 ; Cyan
                 Db    63,00,63 ; Purple
                 Db    00,50,00 ; Green
                 Db    00,00,50 ; Blue
                 Db    63,63,00 ; Yellow
                 Db    63,25,00 ; Orange
                 Db    48,25,00 ; Brown
                 Db    63,25,25 ; Light red
                 Db    16,16,16 ; Gray 1
                 Db    32,32,32 ; Gray 2
                 Db    25,63,25 ; Light green
                 Db    25,25,60 ; Light blue
                 Db    48,48,48 ; Gray 3
Crt_Blank        =     0
Crt_Char         =     2
Crt_Charm        =     4
Crt_Chare        =     6
Crt_Hires        =     8
Crt_Hiresm       =     10
Evendata
Crtmode          Dw    ?
Screenbase       Dw    ?
Screenseg        Dw    ?
Screenofs        Dw    ?
ScreenSize       Dw    ?
Charsetbase      Dw    ?
Charsetseg       Dw    ?
Charsetofs       Dw    ?
CharsetSize      Dw    ?
Hiresbase        Dw    ?
Hiresseg         Dw    ?
Hiresofs         Dw    ?
HiresSize        Dw    ?
Colourbase       Dw    ?
Videoseg         Dw    0A000h
Video_Lock       Db    0
Spritebase       Dw    8 Dup (?)
Spriteseg        Dw    8 Dup (?)
Spriteofs        Dw    8 Dup (?)
Sprite_Sxb       Db    8 Dup (0)
Sprite_Syb       Db    8 Dup (0)
Sprite_Sxw       Dw    8 Dup (0)
Sprite_Syw       Dw    8 Dup (0)
Sprite_Update    Db    0
Sprite_Reimage   Db    0
Sprite_Shown     Db    0
Sprite_Expx      Db    ?
Sprite_Expy      Db    ?
Sprite_Saveofs   =     21*24*2*2
Sprite_ImagePtr  Dw    Sprite_Image+0*2*(21*24*2*2)
                 Dw    Sprite_Image+1*2*(21*24*2*2)
                 Dw    Sprite_Image+2*2*(21*24*2*2)
                 Dw    Sprite_Image+3*2*(21*24*2*2)
                 Dw    Sprite_Image+4*2*(21*24*2*2)
                 Dw    Sprite_Image+5*2*(21*24*2*2)
                 Dw    Sprite_Image+6*2*(21*24*2*2)
                 Dw    Sprite_Image+7*2*(21*24*2*2)
Evendata
Sprite_X         Dw    8 Dup (?)
Sprite_Y         Dw    8 Dup (?)
Sprite_Dx        Dw    24
Sprite_Dy        Dw    50
Raster           Dw    ?
Raster_YMax      = 311

Keyboard         Db    128 Dup (?)
Keymatrix        Db    8 Dup (?)
Key_E0flag       Db    0
Keymap           Db     -1,  77h,  07h,  37h,  01h,  31h,  02h,  32h
                 Db    03h,  33h,  04h,  34h,  50h,  56h,  00h,   -1
                 Db    67h,  11h,  61h,  12h,  62h,  13h,  63h,  14h
                 Db    64h,  15h,  65h,  66h,  10h,  27h,  21h,  51h
                 Db    22h,  52h,  23h,  53h,  24h,  54h,  25h,  26h
                 Db    55h,  17h,  71h,  06h,  41h,  72h,  42h,  73h
                 Db    43h,  74h,  44h,  75h,  45h,  76h,  46h,  16h
                 Db    57h,  47h,   -1,  40h, 0C0h,  50h, 0D0h,  60h
                 Db   0E0h,  30h, 0B0h,   -1,   -1,   -1,   -1,  36h
                 Db   0F0h,   -1,  35h, 0A0h,   -1,  20h,  05h,   -1
                 Db    70h,   -1,  80h,   -1,   -1,   -1,   -1,   -1
                 Db     -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1
                 Db     -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1
                 Db     -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1
                 Db     -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1
                 Db     -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1
Key_Mode         Db    ?
Key_Joystat      Db    ?,?  ; 2,1
Shadowdc00       Db    ?,-1
Key_Keyboard     = 0
Key_Joy1         = 2
Key_Joy2         = 4

Typ_Norm         = 0
Typ_Arom         = 2
Typ_Drom         = 4
Typ_Erom         = 6
Typ_0001         = 8
Typ_Cia1         = 10
Typ_Cia2         = 12
Typ_Sid          = 14
Typ_Vic          = 16
Typ_Video1       = 18
Typ_Video2       = 20
Typ_Video3       = 22
Typ_Video4       = 24
Typ_Video5       = 26
Typ_Video6       = 28
; ---------------------------------------------------------------------------
If Debug Eq 1
  Macro Instruction N,Mne
    Local @@1
    Align 10h
    Db @@1-$-1,Mne
    @@1:
    Align 10h
    E_&N:
  Endm
Else
  Macro Instruction N,Mne
    Align 10h
    E_&N:
  Endm
Endif

Macro Set_C
  Sbb   Reg_C,Reg_C
Endm

Macro Set_Ic
  Sbb   Reg_C,Reg_C
  Not   Reg_C
Endm

Macro Get_C
  Cmp   Bx,Reg_C
Endm

Macro Get_Ic
  Not   Reg_C
  Cmp   Bx,Reg_C
Endm

If Debug Eq 1
  Macro Jmp_Store
    Jmp Store
  Endm
Else
  Macro Jmp_Store
    Mov   Bl,[Gs:Di]
    Jmp   [St_Table+Bx]
  Endm
Endif
