; ---------------------------------------------------------------------------
; Return information about the processor needed to run this program.
; Must not use any non 8086 instruction.
;
; Input:  Actual processor present at runtime.
; Output: 0 for 8086, 1 for 80186, 2 for 80286, ...
; ---------------------------------------------------------------------------
Cpuneed:    Mov   Bx,Sp
            Mov   Ax,[Bx+6]
            Mov   [Cpu],Ax
            Mov   Ax,3
            Retf  2
; ---------------------------------------------------------------------------
; Return information about the video hardware needed to run this program.
;
; Input:  Actual hardware present at runtime:
;    	   1 = Monochrome
;    	   2 = Cga
;          4 = Ega colour
;	   5 = Ega mono
;	   6 = Pga
;          7 = Vga mono
;          8 = Vga colour
;         10 = System 30
;         11 = System 30 mono
;         12 = System 30 colour
; Output: Bit mask indicating allowed hardware.
; ---------------------------------------------------------------------------
Videoneed:  Mov   Bx,Sp
            Mov   Ax,[Bx+6]
            Mov   [Video],Ax
            Mov   Ax,0000000110000000b
            Retf  2
; ---------------------------------------------------------------------------
