; ---------------------------------------------------------------------------
; Handle all stores to the Video Interface Chip (6567-9)
; ---------------------------------------------------------------------------
Vic_Reset:  Push  Ds
            Push  Eax
            Mov   Ds,[Iodirect]
            Xor   Eax,Eax
            Mov   [0D000h],Eax
            Mov   [0D004h],Eax
            Mov   [0D008h],Eax
            Mov   [0D00Ch],Eax
            Mov   [0D010h],Eax
            Mov   [0D014h],Eax
            Mov   [0D018h],Eax
            Mov   [0D01Ch],Eax
            Mov   [0D020h],Eax
            Mov   [0D024h],Eax
            Mov   [0D028h],Eax
            Mov   [0D02Ch],Eax
            Call  Clearhot
            Pop   Eax
            Pop   Ds
            Ret
; ---------------------------------------------------------------------------
Align 2
VicTable    Dw    St_D000,St_D001,St_D002,St_D003
            Dw    St_D004,St_D005,St_D006,St_D007
            Dw    St_D008,St_D009,St_D00a,St_D00b
            Dw    St_D00c,St_D00d,St_D00e,St_D00f
            Dw    St_D010,St_D011,St_D012,St_D013
            Dw    St_D014,St_D015,St_D016,St_D017
            Dw    St_D018,St_D019,St_D01a,St_D01b
            Dw    St_D01c,St_D01d,St_D01e,St_D01f
            Dw    St_D020,St_D021,St_D022,St_D023
            Dw    St_D024,St_D025,St_D026,St_D027
            Dw    St_D028,St_D029,St_D02a,St_D02b
            Dw    St_D02c,St_D02d,St_D02e,St_D02f

Vic_Nc      Db    22 Dup (0),0C0h,0,1,70h,0F0h,5 Dup (0),15 Dup (0F0h),0FFh

Align 10h
St_Vic:     Mov   Bx,Di
            And   Bx,3Fh
            Or    Al,[Vic_Nc+Bx]
            Jmp   [VicTable+Bx+Di-0D000h]

; ---------------------------------------------------------------------------
Align 10h
St_D000:
St_D001:
St_D002:
St_D003:
St_D004:
St_D005:
St_D006:
St_D007:
St_D008:
St_D009:
St_D00a:
St_D00b:
St_D00c:
St_D00d:
St_D00e:
St_D00f:
            Cmp   Al,[Di]
            Je    @@1
            Mov   [Di],Al
            Shr   Bx,1
            Bts   [Word Sprite_Update],Bx
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D010:    Mov   Bl,[Di]
            Mov   [Di],Al
            Xor   Al,Bl
            Or    [Sprite_Update],Al
            Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D011:    Mov   Bl,Al
            Shr   Bl,7
            Mov   [Byte Raster+1],Bl
            And   Al,7Fh
            Mov   Bl,80h
            And   Bl,[Di]
            Or    Al,Bl
            Mov   Bl,[Di]
            Mov   [Di],Al
            Xor   Al,Bl
            Test  Al,01110000b
            Je    @@1
            Call  Flagrefresh
@@1:        Test  Al,00000111b
            Je    @@2
            Mov   Bl,[Di]
            And   Bl,00000111b
            Add   Bl,47
            Mov   [Sprite_Dy],Bx
            Mov   Bl,[Fs:0D015h]
            Or    [Sprite_Update],Bl
@@2:        Jmp   Next
; ---------------------------------------------------------------------------
St_D012:    Mov   [Byte Raster],Al
            Jmp   Next
; ---------------------------------------------------------------------------
St_D013=Next
St_D014=Next
; ---------------------------------------------------------------------------
Align 10h
St_D015:    Mov   Bl,[Di]
            Mov   [Di],Al
            Xor   Al,Bl
            Or    [Sprite_Update],Al
            Or    [Sprite_Reimage],Al
            Call  Clearhotsprite
            Call  Videoremapsprite
            Call  Sethotsprite
            Jmp   Next
; ---------------------------------------------------------------------------
St_D016:    Mov   Bl,[Di]
            Mov   [Di],Al
            Xor   Al,Bl
            Test  Al,00010000b
            Je    @@1
            Call  Flagrefresh
@@1:        Test  Al,00000111b
            Je    @@2
            Mov   Bl,[Di]
            And   Bl,00000111b
            Add   Bl,24
            Mov   [Sprite_Dx],Bx
            Mov   Bl,[Fs:0D015h]
            Or    [Sprite_Update],Bl
@@2:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D017:
St_D01b:
St_D01c:
St_D01d:    Mov   Bl,[Di]
            Mov   [Di],Al
            Xor   Al,Bl
            Or    [Sprite_Update],Al
            Or    [Sprite_Reimage],Al
            Jmp   Next
; ---------------------------------------------------------------------------
St_D018:    Xchg  [Di],Al
            Xor   Al,[Di]
            And   Al,11111110b
            Je    @@1
            Test  [Byte 0D011h],00100000b
            Je    @@2
            And   Al,11111000b
            Je    @@1
@@2:        Call  Flagrefresh
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D019:    Not   Al
            And   [Di],Al
            Test  [Byte Di],7Fh
            Jnz   @@1
            Mov   [Byte Di],0
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D01a:
            Mov   [Di],Al
            Jmp   Next
; ---------------------------------------------------------------------------
St_D01e=Next
St_D01f=Next
; ---------------------------------------------------------------------------
Align 10h
St_D020:    Cmp   Al,[Di]
            Je    @@1
            Mov   [Di],Al
            Mov   Bl,8
            Call  Setpalette1
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
St_D021:
St_D022:
St_D023:
St_D024:
            Cmp   Al,[Di]
            Je    @@1
            Mov   [Di],Al
            Sub   Bl,21h
            Call  Setpalette1
            Add   Bl,4
            Call  Setpalette1
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D025:
St_D026:    Cmp   Al,[Di]
            Je    @@1
            Sub   Bl,25h
            Xor   Bl,1
            Shl   Bl,4
            Add   Bl,28h
@@2:        Call  Setpalette1
            Inc   Bl
            Test  Bl,7
            Jne   @@2
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
Align 10h
St_D027:
St_D028:
St_D029:
St_D02a:
St_D02b:
St_D02c:
St_D02d:
St_D02e:    Cmp   Al,[Di]
            Je    @@1
            Sub   Bl,27h-30h
            Call  Setpalette1
@@1:        Jmp   Next
; ---------------------------------------------------------------------------
St_D02f=Next
